Index: /trunk/Cosmo/RadioBeam/recbeam.pic
===================================================================
--- /trunk/Cosmo/RadioBeam/recbeam.pic	(revision 3163)
+++ /trunk/Cosmo/RadioBeam/recbeam.pic	(revision 3164)
@@ -35,9 +35,9 @@
 
 # 3/ Faire tourner le programme - reconstruction cube X-Y-freq (en dehors de piapp)
-Objs/treccyl XY fourcyl.ppf
+Objs/treccyl XY ncyl.ppf
 
 # 4/ Affichage resultats
 delobjs *
-openppf fourcyl.ppf
+openppf ncyl.ppf
 listobjs
 
@@ -48,7 +48,8 @@
 
 zone 1 3
-disp recXYf0 'zoomx2 grey32 lut=sqrt,0.,0.1'
-disp recXYf1 'zoomx2 grey32 lut=sqrt,0.,0.1'
-disp recXYf2 'zoomx2 grey32 lut=sqrt,0.,0.1'
+disp recXYf0 'zoomx2 grey32 lut=sqrt,0.,1'
+plot2dw ntsrc sin(angrad)*freq*0.25*256+128 sin(angyrad)*freq*0.25*21+10  amp fabs(freqred-0.1)<0.01 'nsta same red marker=circle,7'
+disp recXYf1 'zoomx2 grey32 lut=sqrt,0.,1'
+disp recXYf2 'zoomx2 grey32 lut=sqrt,0.,1'
 
 
@@ -56,3 +57,3 @@
 objaoper recsrcbox slicexy 101
 set cobj /home/slicexy_101
-disp $cobj 'zoomx2 grey32 lut=sqrt,0.,0.1'
+disp $cobj 'zoomx2 grey32 lut=sqrt,0.,1'
Index: /trunk/Cosmo/RadioBeam/treccyl.cc
===================================================================
--- /trunk/Cosmo/RadioBeam/treccyl.cc	(revision 3163)
+++ /trunk/Cosmo/RadioBeam/treccyl.cc	(revision 3164)
@@ -33,7 +33,7 @@
 static double freq0 = 2.;  // frequence de base
 static double da = 0.25;     // pas des antennes le long du cylindre
-static double snoise = 0.; //1.0;   sigma du bruit 
-static double tjit = 0.; //0.05;    sigma du jitter en temps
-static double tos = 0.; //0.02;     sigma des offsets en temps
+static double snoise = 1.0;  // sigma du bruit 
+static double tjit = 0.05;   // sigma du jitter en temps
+static double tos = 0.02;    // sigma des offsets en temps
 static double gmean = 1.;    // gain moyen
 static double gsig = 0.;     // sigma des gains
@@ -149,5 +149,5 @@
 
   // BRSourceGen sg;
-  int nsf = 7;
+  int nsf = 6;
   vector<double> frq;
   frq.push_back(0.1);
@@ -157,9 +157,11 @@
   
   cout << "treccy/testmulticyl: BRSourceGen sg([frq=0.1,0.27,0.38], " << nsf << ")" << endl;
-  BRSourceGen sg(frq, nsf, M_PI/3, M_PI/150);
+  BRSourceGen sg(frq, nsf, M_PI/3, M_PI/60);
+  /*
   int is;
   for(is=0; is<nsf; is++)     sg.angY(is) = 0.;
-  for(is=nsf; is<2*nsf; is++)     sg.angY(is) = M_PI/150.;
-  for(is=2*nsf; is<3*nsf; is++)     sg.angY(is) = -M_PI/150.;
+  for(is=nsf; is<2*nsf; is++)     sg.angY(is) = M_PI/30.;
+  for(is=2*nsf; is<3*nsf; is++)     sg.angY(is) = -M_PI/30.;
+  */
   // sg.WritePPF(string("brsrcm.ppf"));
   // BRSourceGen  sg(string("brsrcm.ppf"));
@@ -177,12 +179,15 @@
   mcyl.SetGains(gmean, gsig, nantgz);
 
+  /*
+  for(int kkc=0; kkc<12; kkc++) 
+    mcyl.AddCylinder(5.*kkc);
+  */
+ 
   mcyl.AddCylinder(0.);
   mcyl.AddCylinder(5.);
-  mcyl.AddCylinder(10.);
-  mcyl.AddCylinder(18.);
-  mcyl.AddCylinder(30.);
-  mcyl.AddCylinder(46.);
-  mcyl.AddCylinder(64.);
-
+  mcyl.AddCylinder(15.);
+  mcyl.AddCylinder(35.);
+  mcyl.AddCylinder(65.);
+ 
   mcyl.SetSources(sg);
   
@@ -190,5 +195,5 @@
 
   //  mcyl.ReconstructCylinderPlaneS(true);
-  mcyl.ReconstructSourceBox(15, M_PI/500.);
+  mcyl.ReconstructSourceBox(10, M_PI/600.);
 
   POutPersist po(ppfname);
@@ -219,15 +224,18 @@
   int kfmin, kfmax;
   po << PPFNameTag("recsrcbox") << mcyl.getRecSrcBox();
-  kfmin = mcyl.getRecSrcBox().SizeZ()*frq[0] - 1;  kfmax = kfmin+2;
+  kfmin = mcyl.getRecSrcBox().SizeZ()/0.5*frq[0] - 2;  kfmax = kfmin+2;
+  cout << "testmulticyl/Info: slice0 kfmin=" << kfmin << " kfmax=" << kfmax << endl;
   {
   TMatrix<r_4> slice0 = mcyl.getRecXYSlice(kfmin, kfmax);
   po << PPFNameTag("recXYf0") << slice0;
   }
-  kfmin = mcyl.getRecSrcBox().SizeZ()*frq[1] - 1;  kfmax = kfmin+2;
+  kfmin = mcyl.getRecSrcBox().SizeZ()/0.5*frq[1] - 2;  kfmax = kfmin+2;
+  cout << "testmulticyl/Info: slice1 kfmin=" << kfmin << " kfmax=" << kfmax << endl;
   {
   TMatrix<r_4> slice1 = mcyl.getRecXYSlice(kfmin, kfmax);
   po << PPFNameTag("recXYf1") << slice1;
   }
-  kfmin = mcyl.getRecSrcBox().SizeZ()*frq[2] - 1;  kfmax = kfmin+2;
+  kfmin = mcyl.getRecSrcBox().SizeZ()/0.5*frq[2] - 2;  kfmax = kfmin+2;
+  cout << "testmulticyl/Info: slice2 kfmin=" << kfmin << " kfmax=" << kfmax << endl;
   {
   TMatrix<r_4> slice2 = mcyl.getRecXYSlice(kfmin, kfmax);