Index: trunk/SophyaLib/BuildMgr/Makefile
===================================================================
--- trunk/SophyaLib/BuildMgr/Makefile	(revision 3130)
+++ trunk/SophyaLib/BuildMgr/Makefile	(revision 3180)
@@ -23,5 +23,4 @@
 	if [ -f $(SOPHYAINCP)/SophyaConfInfo/LinAlg.conf ] ; then cd  ../LinAlg ; $(MAKE) ; fi
 	if [ -f $(SOPHYAINCP)/SophyaConfInfo/XAstroPack.conf ] ; then cd  ../XAstroPack ; $(MAKE) ; fi
-	if [ -f $(SOPHYAINCP)/SophyaConfInfo/MinuitAdapt.conf ] ; then cd  ../MinuitAdapt ; $(MAKE) ; fi
  
 PI::
Index: trunk/SophyaLib/BuildMgr/README
===================================================================
--- trunk/SophyaLib/BuildMgr/README	(revision 3130)
+++ trunk/SophyaLib/BuildMgr/README	(revision 3180)
@@ -28,5 +28,5 @@
 # run the configure script 
 csh> ./configure -sbase $SOPHYABASE -scxx g++ -extp /usr/local 
-     -noext fftw -noext lapack -noext astro -noext minuit
+     -noext fftw -noext lapack -noext astro
 
 2/ compile and build the libraries
@@ -113,5 +113,4 @@
 * XAstroPack/    Interface with astronomy library (XEphem)
                  The XEphem library code is in the SOPHYA module XephemAstroLib
-* MinuitAdapt/   Inteface with the CERN Minuit minimization routines
 
 * XephemAstroLib/ The code of the external XEphem astronomy library, extracted from XEphem
Index: trunk/SophyaLib/BuildMgr/configure
===================================================================
--- trunk/SophyaLib/BuildMgr/configure	(revision 3130)
+++ trunk/SophyaLib/BuildMgr/configure	(revision 3180)
@@ -15,14 +15,14 @@
 set ALLPILIBS = ( '-lPI' '-lPIext' '-lPIGcont' )
 
-set SOPEXT     = ( FitsIOServer  IFFTW  LinAlg  XAstroPack  MinuitAdapt )
-set EXTCURNAME = ( fits          fftw   lapack  astro       minuit      )
-set SOPEXTOK   = ( 1             1      1       1           1           )
-set EXTINCNAME = ( FitsIO/fitsio.h FFTW/fftw3.h  PASDEINC XAstro/astro.h Cern/minuit.h )
-set EXTLIBNAME = ( libcfitsio.a libfftw3.a liblapack.a libxastro.a libminuit.a )
-set ALLEXTLIBS = ( '-lcfitsio' '-lfftw3' '-llapack -lblas' '-lxastro' '-lminuit' )
-
-#FFTW2: set EXTINCNAME = ( FitsIO/fitsio.h FFTW/fftw.h  PASDEINC XAstro/astro.h Cern/minuit.h )
-#FFTW2: set EXTLIBNAME = ( libcfitsio.a libfftw.a liblapack.a libxastro.a libminuit.a )
-#FFTW2: set ALLEXTLIBS = ( '-lcfitsio' '-lfftw -lrfftw' '-llapack -lblas' '-lxastro' '-lminuit' )
+set SOPEXT     = ( FitsIOServer  IFFTW  LinAlg  XAstroPack )
+set EXTCURNAME = ( fits          fftw   lapack  astro      )
+set SOPEXTOK   = ( 1             1      1       1          )
+set EXTINCNAME = ( FitsIO/fitsio.h FFTW/fftw3.h  PASDEINC XAstro/astro.h )
+set EXTLIBNAME = ( libcfitsio.a libfftw3.a liblapack.a libxastro.a )
+set ALLEXTLIBS = ( '-lcfitsio' '-lfftw3' '-llapack -lblas' '-lxastro' )
+
+#FFTW2: set EXTINCNAME = ( FitsIO/fitsio.h FFTW/fftw.h  PASDEINC XAstro/astro.h )
+#FFTW2: set EXTLIBNAME = ( libcfitsio.a libfftw.a liblapack.a libxastro.a )
+#FFTW2: set ALLEXTLIBS = ( '-lcfitsio' '-lfftw -lrfftw' '-llapack -lblas' '-lxastro' )
 
 set defextinc = ( /usr/include /usr/local/include )
@@ -46,5 +46,5 @@
   echo 'configure [-sbase SOPHYABASE] [-scxx SOPHYACXX] [-incln] [-minc mymake.inc] '
   echo '  [-extp dir1 -extp dir2 ...] [-extip dir1 -extip dir2 ... ] [-extlp dir1 -extlp dir2 ... ]'
-  echo '  [-noextlib -noext fits -noext fftw -noext lapack -noext astro -noext minuit]'
+  echo '  [-noextlib -noext fits -noext fftw -noext lapack -noext astro]'
   echo '  [-usefftw2 -uselapack2] [-singleslb]'
   exit -1
Index: trunk/SophyaLib/BuildMgr/domkmf
===================================================================
--- trunk/SophyaLib/BuildMgr/domkmf	(revision 3130)
+++ trunk/SophyaLib/BuildMgr/domkmf	(revision 3180)
@@ -14,5 +14,4 @@
 
 echo " ==== Creation smakefile pour les modules EXTLIBS_SOPHYA ===="
-### ATTENTION ### ne pas faire mkmflib pour MinuitAdapt
 foreach f ( FitsIOServer IFFTW LinAlg XAstroPack )
   set cmd = "./mkmflib $* $f" 
Index: trunk/SophyaLib/BuildMgr/smakefile
===================================================================
--- trunk/SophyaLib/BuildMgr/smakefile	(revision 3130)
+++ trunk/SophyaLib/BuildMgr/smakefile	(revision 3180)
@@ -23,5 +23,4 @@
 	if [ -f $(SOPHYAINCP)/SophyaConfInfo/LinAlg.conf ] ; then cd  ../LinAlg ; $(MAKE) -f smakefile ; fi
 	if [ -f $(SOPHYAINCP)/SophyaConfInfo/XAstroPack.conf ] ; then cd  ../XAstroPack ; $(MAKE) -f smakefile ; fi
-	if [ -f $(SOPHYAINCP)/SophyaConfInfo/MinuitAdapt.conf ] ; then cd  ../MinuitAdapt ; $(MAKE) -f smakefile ; fi
  
 PI::