Index: /trunk/SophyaLib/Manual/perfmachine.txt
===================================================================
--- /trunk/SophyaLib/Manual/perfmachine.txt	(revision 3186)
+++ /trunk/SophyaLib/Manual/perfmachine.txt	(revision 3187)
@@ -8,4 +8,5 @@
 (b) ccali : Bipro-bicoeur Xeon@2.8 GHz Linux (xeon-lx-2.8GHz)  , icc 8.0 ou 9.0
 (c) sgsda: AMD Bipro AMD opteron 248 @ 2.2 GHz (amd-lx-
+(cc) grid-saclay A: MD opteron 275 Bipro-bicoeur  @ 2.2 GHz (amd275-lx)
 
 (d) asc: bipro alpha (@ ~1 GHz) server DS20 OSF (osf1)  , cxx 6.5 (osf-asc)
@@ -19,5 +20,5 @@
 (j) MacPro-Grosdidier : Apple / Xeon 2 double-coeur @ 3 GHz gcc 4.0.1 , compil SOPHYA -O2 -g
 
-(p) IBM-AIX regatta , xlC , 
+(p) IBM-AIX regatta , xlC , IBM eServer pSeries 655 , 8 proc power4 @ 1.1 GHz
 
 
@@ -27,4 +28,24 @@
 La machine MacPro avec OSX se debrouille quand meme mieux.
 - Effet du systeme ou carte mere ??? 
+
+
+Donnees SPECint2000 (3) / SPECfp2000 (2) (http//www.spec.org)
+(1) MFLOPS  -> cpupower 2
+----------------------------------------------------------------------
+                         MFLOPS(1)      SPECfp      SPECint 
+----------------------------------------------------------------------
+(b)xeon-lx-2.8GHz         900            1400        1400
+(c)amd-lx                 690            1600        1300
+(cc)amd2-lx               675            1600        1300
+
+(d)osf-xp1000             648             500         400
+(e)superosf               842            1100         700
+
+(i)core-osx-1.83GHz       855            1400        1500
+(j)xeon-osx              2600            2900          -
+
+(p)ibm-aix                700            1050         700
+----------------------------------------------------------------------
+
 
 A/ Compilation tout SOPHYA 
@@ -67,6 +88,6 @@
 (i) 83 MO
 
-B/ Calcul brut avec / sans threads
------------------------------------
+B/ Calcul brut (Tableaux de SOPHYA) avec / sans threads
+--------------------------------------------------------
 
 B.1/ arr = c1*a1+c2*a2
@@ -89,4 +110,8 @@
                                            (4)13.5/7/193%
                                            (5)20.3/10.23/198%
+(cc)amd2-lx            675        2/2/99%                   4.15/2.1/197%
+                                           (4)8.25/4.15/198%
+                                           (5)13.6/4.6/292%
+                                           (6)19.8/6.5/300%
 
 (d)osf-xp1000          648        5.1/5.3/96.6%            11.4/11.4/99%       
@@ -141,4 +166,9 @@
                                            (5) 41.4/21.07/196%
                                            (6) 55.4/27.9/198.7%  
+(cc)amd2-lx            675        4.1/4.1/100%               9.55/4.8/198%
+                                           (4) 20/10.27/195%
+                                           (5) 32.8/11.16/294%
+                                           (6) 42.75/13.8/309%
+
 
 (d)osf-xp1000          648        13/14.1/92%                27.1/27.4/99%
@@ -176,5 +206,6 @@
  -----------------------------------------------------------------------------------
 
-B.3/ Tests fft (FFTW , FFTPack )
+C/ Calcul fft (FFTW , FFTPack )
+-------------------------------
 
 (1) time cpupower 2 
@@ -193,4 +224,5 @@
 (c)amd-lx              690                                       4.2/4.2/100%     238
                                                             ~2x  4.7/4.7/99%
+(cc)amd2-lx            675        2.8/2.8/99%                    3.56/3.58/99%
 
 (d)osf-xp1000          648        9.9/10.2/97%       101        9.3/9.46/98.5%    107     
@@ -212,2 +244,32 @@
 (q)sgi-magique         460        22/22/98%           42         24.5/25/99%       40           
  -----------------------------------------------------------------------------------
+
+
+D/ Efficacite de gestion de lock (mutex) avec les threads
+-----------------------------------------------------------
+(32 threads - operant sur 2000 vecteurs ~ 64000 lock/unlock/wait/broadcast)
+
+csh> time zthr syncp 32 2000 4 
+(1) time cpupower 2 
+
+----------------------------------------------------------------------
+                        (1)MFLOPS   CPU(s)  IndPerf   TCPU/Elapsed %
+----------------------------------------------------------------------
+(a)xeon-lx-2.4GHz        1167       17.8                   178%
+      avec -O3 -g 
+(b)xeon-lx-2.8GHz (2)     
+(c)amd-lx                 690       0.4                     31%
+
+(d)osf-xp1000 (1)        
+(e)superosf (1)          
+(f)osf-asc (1)           420        5.4                    100%
+
+(f)G4-osx-1.25GHz (1)    333        64                      96%
+(h)G5-osx-1GHz (2)      1150        2.6                    130%                   
+    -tune=G5            
+(i)core-osx-1.83GHz 
+              -O2   
+(j)xeon-osx             2600        2.55                   143%
+
+(p)ibm-aix               700        4.7                    111%
+----------------------------------------------------------------------